#include <regex.h>

/* You can edit MYSQL_??? definitions
 * indexer will use it to connect to MySQL database by default
 * But better (and more secure) way is to provide
 * that information in template
 *
 * Please see README.templates for details
 */

#define MYSQL_HOST	"localhost"
#define MYSQL_DB	"udmsearch"
#define MYSQL_USER	"foo"
#define MYSQL_PASS	"bar"

#define INDEXER_USER_AGENT "UdmSearch"
#define DEFAULT_PROXY_PORT 3128

#define MAXFILTER	128

#define DEFAULT_REINDEX_TIME	7*24*60*60
#define DEFAULT_MAX_HOPS	256
#define READ_TIMEOUT		90
#define MAXNETERRORS		16


#define MAXDOCSIZE	1024*1024  /* 1Mb */
#define MAXTEXTSIZE	128
#define MAXTITLESIZE	128
#define MAXKEYWORDSIZE	255
#define MAXDESCSIZE	100
#define WSIZE		1024
#define STRSIZ		1024

/* This is syslog facility we use while logging */
/* See syslog.conf(5) & syslog(3) man page for details */
/* #define LOG_FACILITY	LOG_LOCAL7 */

/****
 * Nothing should be edited below!
 */

#define F_ALLOW    0
#define F_DISALLOW 1
#define F_HEAD     2

  
/* Verbose levels */
#define ERROR		1
#define WARNING		2
#define INFO		3
#define EXTRA		4
#define DEBUG		5

/* We use only two syslog priorities - LOG_INFO & LOG_ERR
If we have no syslog, use stdout and stderr respectively */

extern int is_log_open;
extern int loglevel;

#ifdef USE_SYSLOG
#define LOG(l,a) 	if(loglevel>=l) syslog((l!=ERROR)?LOG_INFO:LOG_ERR,a)
#define LOG2(l,a,b)	if(loglevel>=l) syslog((l!=ERROR)?LOG_INFO:LOG_ERR,a,b)
#define LOG3(l,a,b,c)	if(loglevel>=l) syslog((l!=ERROR)?LOG_INFO:LOG_ERR,a,b,c)
#define LOG4(l,a,b,c,d)	if(loglevel>=l) syslog((l!=ERROR)?LOG_INFO:LOG_ERR,a,b,c,d)
#else
#define LOG(l,a) 	if(loglevel>=l){fprintf((l!=ERROR)?stdout:stderr,a);    fprintf((l!=ERROR)?stdout:stderr,"\n");}
#define LOG2(l,a,b)	if(loglevel>=l){fprintf((l!=ERROR)?stdout:stderr,a,b);  fprintf((l!=ERROR)?stdout:stderr,"\n");}
#define LOG3(l,a,b,c)	if(loglevel>=l){fprintf((l!=ERROR)?stdout:stderr,a,b,c);fprintf((l!=ERROR)?stdout:stderr,"\n");}
#define LOG4(l,a,b,c,d)	if(loglevel>=l){fprintf((l!=ERROR)?stdout:stderr,a,b,c,d);fprintf((l!=ERROR)?stdout:stderr,"\n");}
#endif



typedef struct word_struct {
	int count;
	char *word;
} WORD;

typedef struct robots_struct {
	char *hostinfo;
	char *path;
} ROBOT;

typedef struct server_struct {
	char *url;
	char *charset;
	char *proxy;
	char *basic_auth;
	int  proxy_port;
	int  period;
	int  hint;
	int  net_errors;
	int  max_net_errors;
	int  read_timeout;
	int  outside;
	int  maxhops;
	int  gindex;
	int  gfollow;
	int  deletebad;
	int  userobots;
	int  bodyweight;
	int  titleweight;
	int  urlweight;
	int  descweight;
	int  keywordweight;
} SERVER;

typedef struct filter_struct {
	regex_t filter;
	int     filter_type;
} FILTER;
